' identical.VBS V1.00 (C) yoshioka.teruo@nifty.com 2004-10-25
' identical.VBS compares folders and finds identical files.

Option Explicit

Sub Usage()
If k<WScript.Arguments.Count Then
  WScript.Echo "Invalid Option :",WScript.Arguments(k)
End If
WScript.Echo "Usage: CScript identical.VBS src [option] <condition> <action>" & _
vbCRLF & "<option>" & _
vbCRLF & "-n: NOP" & _
vbCRLF & "-s: Silent" & _
vbCRLF & "-nr: Not Recursive" & _
vbCRLF & "-t: Tree" & _
vbCRLF & "<condition>" & _
vbCRLF & "-comp dst: compare file content of src and dst. If same, do action." & _
vbCRLF & "<action>" & _
vbCRLF & "-print: print file name." & _
vbCRLF & "-rename: rename src file to dst." & _
vbCRLF & "-rm: remove src file." & _
""
WScript.Quit
End Sub

Dim fso
Dim StdErr
Dim sFolder
Dim dFolder
Dim action
Const print=1
Const rename=2
Const remove=3
Dim k
Dim arg
Dim Nop
Dim Silent
Dim Prompt
Dim Tree
Dim NR

Set fso=CreateObject("Scripting.FileSystemObject")
Set StdErr=WScript.StdOut
If WScript.Arguments.Count=0 Then Call Usage()
Set sFolder=fso.GetFolder(WScript.Arguments(0))
For k=1 To WScript.Arguments.Count-1
Select Case LCase(WScript.Arguments(k))
Case "-n" Nop=True
Case "-s" Silent=True
Case "-p" Prompt=True
Case "-nr" NR=True
Case "-t" Tree=True
Case "-comp"
  If Not IsEmpty(dFolder) Then Call Usage
  k=k+1
  Set dFolder=fso.GetFolder(WScript.Arguments(k))
Case "-print"
  If Not IsEmpty(action) Then Call Usage
  action=print
  Set StdErr=WScript.StdErr
Case "-rm"
  If Not IsEmpty(action) Then Call Usage
  action=remove
Case "-rename"
  If Not IsEmpty(action) Then Call Usage
  action=rename
Case Else Call Usage
End Select
Next

If IsEmpty(dFolder) Then Call Usage
If sFolder Is dFolder Then
  WScript.Echo "Specify different folders"
  WScript.Quit
End If

Call FolderProc(sFolder)
WScript.Quit

Function FolderProc(Folder)
Dim src
If NR=False Then
  For Each src In Folder.SubFolders
    Call FolderProc(src)
  Next
End If

For Each src In Folder.Files
  Call FileProc(src)
Next
End Function

Const fNotExists=1
Const fExists=0
Const fSame=0
Const fNotSize=2
Const fNotContent=1

Function FileProc(sFile)
Dim fTest
Dim dFile
If Tree Then
  dFile=fso.BuildPath(dFolder.Path,Mid(sFile.Path,Len(sFolder.Path)+1))
Else
  dFile=fso.BuildPath(dFolder.Path,sFile.Name)
End If
fTest=FileTest(sFile,dFile)
If fTest=fSame Then Call DoAction(sFile,dFile)
End Function

Function DoAction(sFile,dFile)
Dim ans
Dim ErrNumber
Dim ErrDescription
  Select Case Action
  Case print
    WScript.Echo sFile
  Case rename
    If sFile.Name=dFile.Name Then
      WScript.Echo "Already same name."
      Exit Function
    End If
    If Prompt Then
      WScript.StdOut.Write "rename ?"
      ans=WScript.StdIn.ReadLine
      If LCase(ans)<>"y" Then
        WScript.StdOut.WriteLine "canceled."
        Exit Function
      End If
    End If
    On Error Resume Next
    If Nop=False Then
      sFile.Name=dFile.Name
    End If
    ErrNumber=Err.Number
    ErrDescription=Err.Description
    On Error GoTo 0
    If ErrNumber=0 Then
      If Silent=False Then WScript.Echo "renamed."
    Else
      WScript.Echo "rename failed. Code:" & ErrNumber & " Reason:" & ErrDescription
    End If
  Case remove
    If Prompt Then
      WScript.StdOut.Write "remove ?"
      ans=WScript.StdIn.ReadLine
      If LCase(ans)<>"y" Then
        WScript.StdOut.WriteLine "canceled."
        Exit Function
      End If
    End If
    On Error Resume Next
    If Nop=False Then
      sFile.Delete
    End If
    ErrNumber=Err.Number
    ErrDescription=Err.Description
    On Error GoTo 0
    If ErrNumber=0 Then
      If Silent=False Then WScript.Echo "removed."
    Else
      WScript.Echo "remove failed. Code:" & ErrNumber & " Reason:" & ErrDescription
    End If
  Case Else
  End Select
End Function

Function FileTest(sFile,dFile)
Dim fCompare
Dim Folder
'wscript.echo dfile
Folder=fso.GetParentFolderName(dFile)
If fso.FolderExists(Folder)=False Then
  FileTest=fNotExists
  Exit Function
End If
Set Folder=fso.GetFolder(Folder)
For Each dFile In Folder.Files
  If dFile.Size=sFile.Size Then
    fCompare=Compare(sFile.Path,dFile.Path)
    If fCompare=fSame Then
      StdErr.WriteLine sFile.Path & " -- " & dFile.Path 
      FileTest=fCompare
      Exit Function
    End If
  End If
Next
StdErr.WriteLine sFile.Path & " -- dosen't exists."
FileTest=fNotExists
End Function

Function Compare(srcFile,dstFile)
  Dim Src
  Dim Dst
  Const adTypeBinary=1

  Compare=fSame
  Set Src=fso.GetFile(srcFile)
  Set Dst=fso.GetFile(dstFile)
  If Src.Size<>Dst.Size Then
    Compare=fNotSize
    Exit Function
  End If

  Set Src=CreateObject("ADODB.Stream")
  Call Src.Open()
  Src.Type=adTypeBinary
  Call Src.LoadFromFile(srcFile)

  Set Dst=CreateObject("ADODB.Stream")
  Dst.Type=adTypeBinary
  Call Dst.Open()
  Call Dst.LoadFromFile(dstFile)

  If Src.Size<>Dst.Size Then
    Compare=fNotSize
  Else
    Do Until Src.EOS
      If CStr(Src.Read(4096))<>CStr(Dst.Read(4096)) Then
       Compare=fNotContent
        Exit Do
      End If
    Loop
  End If
  Src.Close
  Dst.Close
  Set Src=Nothing
  Set Dst=Nothing
End Function
